package com.bugsee;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import com.facebook.react.TurboReactPackage;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.module.model.ReactModuleInfo;
import com.facebook.react.module.model.ReactModuleInfoProvider;
import com.facebook.react.modules.network.OkHttpClientFactory;
import com.facebook.react.uimanager.ViewManager;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BugseeReactPackage extends TurboReactPackage {
    private static final boolean isTurboModule = BuildConfig.IS_NEW_ARCHITECTURE_ENABLED;
    
    public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
        return Collections.emptyList();
    }
    
    // @Override
    // public List<NativeModule> createNativeModules(
    //         ReactApplicationContext reactContext) {
    //     List<NativeModule> modules = new ArrayList<>();
    
    //     modules.add(new BugseeNativeBridge(reactContext));
    
    //     return modules;
    // }
    
    @Nullable
    @Override
    public NativeModule getModule(String name, ReactApplicationContext reactContext) {
        if (BugseeNativeBridgeImpl.NAME.equals(name)) {
            return new BugseeNativeBridge(reactContext);
        }

        return null;
    }
    
    @Override
    public ReactModuleInfoProvider getReactModuleInfoProvider() {
        return () -> {
            final Map<String, ReactModuleInfo> moduleInfos = new HashMap<>();
            moduleInfos.put(
                BugseeNativeBridgeImpl.NAME,
                new ReactModuleInfo(
                    BugseeNativeBridgeImpl.NAME,
                    BugseeNativeBridgeImpl.NAME,
                    false,          // canOverrideExistingModule
                    false,          // needsEagerInit
                    true,           // hasConstants
                    false,          // isCxxModule
                    isTurboModule   // isTurboModule
                )
            );
            
            return moduleInfos;
        };
    }

    public static OkHttpClientFactory getDefaultHttpFactory() {
        return BugseeNativeBridgeImpl.getDefaultHttpFactory();
    }
}